SystemOrganization addCategory: #reunidosTADP!

Trait named: #CosteablePorHora
	uses: {}
	category: 'reunidosTADP'!

!CosteablePorHora methodsFor: 'as yet unclassified' stamp: 'Paul 4/17/2012 16:29'!
costoPara: unaReunion
	"calcula el costo para una reunion en base de la duracion de la reunion y el costo por hora"

	^ unaReunion duracion * self costoPorHora! !

Trait named: #Disponible
	uses: {}
	category: 'reunidosTADP'!

!Disponible commentStamp: 'Paul 4/17/2012 16:34' prior: 0!
Trait que se encarga implementa eel metodo disponibleEn: unDia por: cantHoras.

Class Instance Variables:
	name	<Object>
	environment	<SmalltalkImage | (SystemDictionary of: ProtoObject)>
	classTrait	<ClassTrait>
	category	<ProtoObject>!

!Disponible methodsFor: 'as yet unclassified' stamp: 'Paul 4/17/2012 15:53'!
disponibleEn: unDia por: cantHoras
	"responde si esta disponible en cierto dia por una cantidad de horas continuas"

	| compromisos |
	compromisos := self compromisos.	
		
	"No esta implementado!!
	Tendria que pedir los compromisos para unDia y ver si tiene cantHoras cintinuas entre los compromisos"
	^ false! !

Trait named: #Horario
	uses: {}
	category: 'reunidosTADP'!

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:10'!
horarioOcupado
 "forma parte del contrato de uso del Trait, es un accesor de las instancias de los objetos que usan Horario"! !

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:11'!
tenesDisponible: unRango

	^self horarioOcupado allSatisfy: [:rango | (rango overlaps: unRango) not]! !

Object subclass: #Catering
	uses: Horario
	instanceVariableNames: 'horarioOcupado costo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Catering class
	uses: Horario classTrait
	instanceVariableNames: ''!

Object subclass: #CriterioMultiple
	instanceVariableNames: 'criterios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:11'!
criterios
^criterios! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:13'!
criterios: unaColeccionDeSimbols
criterios:= unaColeccionDeSimbols ! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:11'!
filtra: unaColeccionDePersonas
unaColeccionDePersonas select: [:candidato | self criterios allSatisfy: [:c| candidato c.]]! !

Object subclass: #CriterioUnico
	instanceVariableNames: 'condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 19:30'!
condicion: unSimbol
condicion:= unSimbol! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 19:30'!
filtra: unaColeccionDePersonas
unaColeccionDePersonas select: [:candidato | self condicion: candidato]
! !

Object subclass: #Notebook
	uses: Horario
	instanceVariableNames: 'horarioOcupado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Notebook class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Notebook methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:28'!
horarioOcupado 
	^horarioOcupado ! !

!Notebook methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:25'!
initialize 
	horarioOcupado := Set new.! !

Object subclass: #Persona
	uses: Horario + Disponible + CosteablePorHora @ {#costoPara:->#costoGeneralPara:}
	instanceVariableNames: 'proyecto rol sector edificio nombre compromisos costoPorHora horarioOcupado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!Persona commentStamp: 'Paul 4/17/2012 16:37' prior: 0!
Representa a una Persona que puede ser Convocante o Aisistente de una Reunion. 
Como usa trait Disponible tiene que implementar mensaje "compromisos".
Como usa trait CosteablePorHora tiene que implementar mensaje "costoPorHora".
Implementa interfaz Recurso, por eso tiene que sorbreescribir los mentodos:
- disponibleEn: unDia por: horas
- costoPara: unaReunion

Instance Variables:
	proyecto	<ProtoObject | PseudoContext>
	rol	<ProtoObject | PseudoContext>
	sector	<ProtoObject | PseudoContext>
	edificio	<ProtoObject | PseudoContext>
	nombre	<ProtoObject | PseudoContext>
	compromisos	<ProtoObject | PseudoContext>!

Persona class
	uses: Disponible classTrait + CosteablePorHora classTrait + Horario classTrait
	instanceVariableNames: ''!

!Persona class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/14/2012 12:02'!
nuevaAsignadaA: unProyecto conRol: unRol enUnEdificio: unEdificio
self new proyecto: unProyecto; rol: unRol; edificio: unEdificio.! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
compromisos
	^ compromisos! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
compromisos: anObject
	compromisos := anObject! !

!Persona methodsFor: 'as yet unclassified' stamp: 'Paul 4/17/2012 16:29'!
costoPara: unaReunion
	"calcula el costo para una reunion solo si el convocante es de otro proyecto"

	(unaReunion convocante proyecto equals: self proyecto)
		ifTrue: [ ^ 0 ]
		ifFalse: [ ^ self costoGeneralPara: unaReunion ]! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 16:31'!
costoPorHora
	^ costoPorHora! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 16:31'!
costoPorHora: anObject
	costoPorHora := anObject! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
edificio
	^ edificio! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
edificio: unEdificio
edificio:= unEdificio! !

!Persona methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:16'!
horarioOcupado 
^horarioOcupado ! !

!Persona methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:17'!
initialize 
 horarioOcupado := Set new.! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 13:30'!
nombre
^nombre! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 13:22'!
nombre: unNombre
nombre:= unNombre! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
proyecto
	^ proyecto! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
proyecto: unProyecto
proyecto:= unProyecto! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
rol
	^ rol! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
rol: unRol
rol:= unRol! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
sector
	^ sector! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
sector: anObject
	sector := anObject! !

Object subclass: #Proyector
	uses: Horario
	instanceVariableNames: 'horarioOcupado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Proyector class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Proyector methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:27'!
horarioOcupado 
	^horarioOcupado ! !

!Proyector methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:25'!
initialize 
	horarioOcupado := Set new.! !

Object subclass: #Requerimiento
	instanceVariableNames: 'rol proyecto sector nombre requerimientosDeTurno'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!Requerimiento commentStamp: 'ClaraAllende 4/13/2012 13:21' prior: 0!
Esta clase representa los posibles requerimientos para convocar a una persona a una reunin. Se puede instanciar un requerimiento usando todos los mensajes definidos (rol, proyecto, sector, nombre) o combinaciones de ellos.

Instance Variables:
	rol	<ProtoObject | PseudoContext>
	proyecto	<ProtoObject | PseudoContext>
	sector	<ProtoObject | PseudoContext>
	nombre	<ProtoObject | PseudoContext>!

!Requerimiento class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:19'!
nuevoConReqs: unosReqs 
^self new requerimientosDeTurno: unosReqs.! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 19:23'!
filtrarPor: unaColeccinDeCriterios

unaColeccinDeCriterios do: [:criterio | criterio filtra: self personas].
! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:20'!
nombre
^nombre! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:20'!
nombre: unNombre
nombre:= unNombre ! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/13/2012 11:40'!
proyecto
^proyecto! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/13/2012 11:40'!
proyecto: unProyecto
proyecto:= unProyecto ! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:17'!
requerimientosDeTurno 
^requerimientosDeTurno! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:17'!
requerimientosDeTurno: unosReqs
requerimientosDeTurno:= unosReqs.! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/13/2012 11:39'!
rol
^rol! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/13/2012 11:39'!
rol: unRol
rol:= unRol! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/13/2012 11:41'!
sector
^sector! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/13/2012 11:40'!
sector: unSector
sector:= unSector! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:16'!
selecccionrAsistentes
self filtrarPor: self requerimientosDeTurno! !

Object subclass: #Reunion
	instanceVariableNames: 'host asistentes recursos edificio duracion requerimiento proyecto horarioOcupado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Reunion class
	instanceVariableNames: 'duracion'!

Reunion class
	instanceVariableNames: 'duracion'!

!Reunion class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/14/2012 12:03'!
nuevaConRequerimiento: unRequerimiento convocadaPor: unHost
self new host: unHost; requerimiento: unRequerimiento.! !

!Reunion class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 18:38'!
nuevaConRequerimiento: unRequerimiento convocadaPor: unHost duracion:  duracion
self new host: unHost; requerimiento: unRequerimiento; duracion: duracion.! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:14'!
convocarAsistentes
	self asistentes: self requerimiento seleccionarAsistentes! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:46'!
duracion
^duracion! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:43'!
duracion: unaDuracion
duracion:= unaDuracion ! !

!Reunion methodsFor: 'accessing' stamp: 'LucasGiudice 4/18/2012 10:26'!
horarioOcupado 
	^horarioOcupado ! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:44'!
host
^host! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:52'!
host: elHost
host:= elHost! !

!Reunion methodsFor: 'accessing' stamp: 'LucasGiudice 4/18/2012 10:26'!
initialize 
	horarioOcupado := Set new.! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/13/2012 13:37'!
proyecto
^self host proyecto.! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:44'!
requerimiento
^requerimiento! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/12/2012 12:55'!
requerimiento: unRequerimiento
requerimiento:= unRequerimiento! !

Object subclass: #Sala
	uses: Horario
	instanceVariableNames: 'canionesYLaptops horarioOcupado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Sala class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Sala methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:27'!
horarioOcupado 
	^horarioOcupado ! !

!Sala methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:27'!
initialize 
	horarioOcupado := Set new.! !

!Sala methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 17:52'!
recursosDisponibles
^self recursos select: [:recurso | recurso estaDisponible]! !

Object subclass: #Transporte
	uses: Horario
	instanceVariableNames: 'horarioOcupado costo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Transporte class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Transporte methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:27'!
horarioOcupado 
	^horarioOcupado ! !

!Transporte methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:27'!
initialize 
	horarioOcupado := Set new.! !
